P8086          ;select the processor
MODEL TINY     ;always must be TINY model

DATASEG
  WelcomeStr db 'Change default port for send85 v2.0. By Magnus Svedin.', 0ah, 0dh, '$'
  TypeStr db 'Do you want to use a [S]erial or a [P]aralell link? $'
  AdrStr db 'What is the base adress of the port you want to use? ____', 08h, 08h, 08h, 08h, '$'
  FileErrorStr db 'Error accessing send85.exe$'
  FileName db 'send85.exe', 0
  NewLine db 0ah, 0dh, '$'
  OkMessage db 'Adress and link type changed.$'

UDATASEG
  PortType db ?
  PortAdr1 db ?
  PortAdr2 db ?
  FileHandle dw ?
  buffer1 db ?
  buffer2 db ?
  fpos dw ?

  DW 100H DUP (?)

CODESEG        ;this marks the start of executable code
  STARTUPCODE

  mov dx, offset WelcomeStr     ;Print welcometext
  mov ah, 09h
  int 21h

  mov dx, offset TypeStr        ;Ask for linktype
  mov ah, 09h
  int 21h

PortReadAnswer:
  mov ah, 01h                   ;read response
  int 21h
  cmp al, 's'
  je PortIsCom
  cmp al, 'S'
  je PortIsCom
  cmp al, 'p'
  je PortIsPrl
  cmp al, 'P'
  je PortIsPrl
  mov dl, 08h                   ;erase char if invalid
  mov ah, 02h
  int 21h
  jmp PortReadAnswer            ;re-read if response was invalid
PortIsCom:                      ;set PortType
  mov [PortType], 00h
  jmp PortDone
PortIsPrl:
  mov [PortType], 01h
PortDone:
  mov dx, offset NewLine        ;Move to next line
  mov ah, 09h
  int 21h

  mov dx, offset AdrStr        ;Ask for linkadr
  mov ah, 09h
  int 21h

  mov ah, 01h                 ;Read first digit of second byte
  int 21h
  call ascii2bin
  sal al, 04h
  mov [PortAdr2], al
  mov ah, 01h                 ;Read second digit of second byte
  int 21h
  call ascii2bin
  or [PortAdr2], al
  mov ah, 01h                 ;Read first digit of first byte
  int 21h
  call ascii2bin
  sal al, 04h
  mov [PortAdr1], al
  mov ah, 01h                 ;Read second digit of first byte
  int 21h
  call ascii2bin
  or [PortAdr1], al

  mov ah, 09h                 ;Change to next line
  mov dx, offset NewLine
  int 21h

  mov dx, offset FileName     ;open file
  mov ax, 3d01h
  int 21h
  jc FileError

  mov bx, ax

  mov ax, 4200h               ;position file where adress is located
  mov cx, 00h
  mov dx, 0cc9ch
  int 21h
  jc FileError

  mov ah, 40h                 ;write new adress
  mov cx, 02h
  mov dx, offset PortAdr1
  int 21h
  jc FileError

  mov ax, 4201h               ;position file where porttype is located
  mov cx, 00h
  mov dx, 02h
  int 21h
  jc FileError

  mov ah, 40h                 ;write new porttype
  mov cx, 01h
  mov dx, offset PortType
  int 21h
  jc FileError

  mov ah, 3eh                 ;close file
  int 21h
  jc FileError

  mov dx, offset OkMessage    ;Display ok-message
  mov ah, 09h
  int 21h

  MOV AL,1

  ;Exit to DOS when complete
  MOV AH,4CH
  INT 21H
  RET

FileError:
  mov ah, 09h                 ;display errormessage
  mov dx, offset FileErrorStr
  int 21h
  mov ax, 4c00h                 ;end program
  int 21h
  ret

PROC ascii2bin
  cmp al, 30h   
  jb NotDeci
  cmp al, 39h
  ja NotDeci
  sub al, 30h
  ret
NotDeci:
  cmp al, 41h
  jb NotCap
  cmp al,  46h
  ja NotCap
  sub al, 37h
  ret
NotCap:
  cmp al, 61h
  jb NotVer
  cmp al, 66h
  ja NotVer
  sub al, 57h
  ret
NotVer:
  mov al, 00h
  ret
ascii2bin ENDP

END
